#! /usr/bin/python

from twisted.internet import defer

from petmail.interfaces import IRequest

class Request(object):
    __implements__ = (IRequest,)

    def __init__(self, description, results):
        self.description = description
        self.deferred = defer.Deferred()
        self.results = results
        self.active = True
        
    def fire(self):
        self.active = False
        self.deferred.callback(self.results)

    def why(self):
        why = self.description
        if not self.active:
            why += " (inactive)"
        return why
